/* SettingsOption.c generated by valac 0.52.4, the Vala compiler
 * generated from SettingsOption.vala, do not modify */

/*
 * Copyright 2011-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "notifications.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite.h>
#include <float.h>
#include <math.h>

enum  {
	WIDGETS_SETTINGS_OPTION_0_PROPERTY,
	WIDGETS_SETTINGS_OPTION_IMAGE_PATH_PROPERTY,
	WIDGETS_SETTINGS_OPTION_TITLE_PROPERTY,
	WIDGETS_SETTINGS_OPTION_DESCRIPTION_PROPERTY,
	WIDGETS_SETTINGS_OPTION_WIDGET_PROPERTY,
	WIDGETS_SETTINGS_OPTION_NUM_PROPERTIES
};
static GParamSpec* widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _WidgetsSettingsOptionPrivate {
	gchar* _image_path;
	gchar* _title;
	gchar* _description;
	GtkWidget* _widget;
	GtkImage* image;
	GtkSettings* gtk_settings;
};

static gint WidgetsSettingsOption_private_offset;
static gpointer widgets_settings_option_parent_class = NULL;
static GtkCssProvider* widgets_settings_option_css_provider;
static GtkCssProvider* widgets_settings_option_css_provider = NULL;

static void widgets_settings_option_update_image_resource (WidgetsSettingsOption* self);
static GObject * widgets_settings_option_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _widgets_settings_option___lambda6_ (WidgetsSettingsOption* self);
static void __widgets_settings_option___lambda6__g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void widgets_settings_option_finalize (GObject * obj);
static GType widgets_settings_option_get_type_once (void);
static void _vala_widgets_settings_option_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_widgets_settings_option_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
widgets_settings_option_get_instance_private (WidgetsSettingsOption* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsSettingsOption_private_offset);
}

WidgetsSettingsOption*
widgets_settings_option_construct (GType object_type,
                                   const gchar* image_path,
                                   const gchar* title,
                                   const gchar* description,
                                   GtkWidget* widget)
{
	WidgetsSettingsOption * self = NULL;
	g_return_val_if_fail (image_path != NULL, NULL);
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (description != NULL, NULL);
	g_return_val_if_fail (widget != NULL, NULL);
	self = (WidgetsSettingsOption*) g_object_new (object_type, "image-path", image_path, "title", title, "description", description, "widget", widget, NULL);
	return self;
}

WidgetsSettingsOption*
widgets_settings_option_new (const gchar* image_path,
                             const gchar* title,
                             const gchar* description,
                             GtkWidget* widget)
{
	return widgets_settings_option_construct (WIDGETS_TYPE_SETTINGS_OPTION, image_path, title, description, widget);
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static void
widgets_settings_option_update_image_resource (WidgetsSettingsOption* self)
{
	GtkSettings* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->gtk_settings;
	g_object_get (_tmp0_, "gtk-application-prefer-dark-theme", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		GtkImage* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp3_ = self->priv->image;
		_tmp4_ = self->priv->_image_path;
		_tmp5_ = string_replace (_tmp4_, ".svg", "-dark.svg");
		_tmp6_ = _tmp5_;
		g_object_set (_tmp3_, "resource", _tmp6_, NULL);
		_g_free0 (_tmp6_);
	} else {
		GtkImage* _tmp7_;
		const gchar* _tmp8_;
		_tmp7_ = self->priv->image;
		_tmp8_ = self->priv->_image_path;
		g_object_set (_tmp7_, "resource", _tmp8_, NULL);
	}
}

const gchar*
widgets_settings_option_get_image_path (WidgetsSettingsOption* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_image_path;
	result = _tmp0_;
	return result;
}

static void
widgets_settings_option_set_image_path (WidgetsSettingsOption* self,
                                        const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_settings_option_get_image_path (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_image_path);
		self->priv->_image_path = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_IMAGE_PATH_PROPERTY]);
	}
}

const gchar*
widgets_settings_option_get_title (WidgetsSettingsOption* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}

static void
widgets_settings_option_set_title (WidgetsSettingsOption* self,
                                   const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_settings_option_get_title (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_title);
		self->priv->_title = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_TITLE_PROPERTY]);
	}
}

const gchar*
widgets_settings_option_get_description (WidgetsSettingsOption* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_description;
	result = _tmp0_;
	return result;
}

static void
widgets_settings_option_set_description (WidgetsSettingsOption* self,
                                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_settings_option_get_description (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_description);
		self->priv->_description = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_DESCRIPTION_PROPERTY]);
	}
}

GtkWidget*
widgets_settings_option_get_widget (WidgetsSettingsOption* self)
{
	GtkWidget* result;
	GtkWidget* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_widget;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
widgets_settings_option_set_widget (WidgetsSettingsOption* self,
                                    GtkWidget* value)
{
	GtkWidget* old_value;
	g_return_if_fail (self != NULL);
	old_value = widgets_settings_option_get_widget (self);
	if (old_value != value) {
		GtkWidget* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_widget);
		self->priv->_widget = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_WIDGET_PROPERTY]);
	}
}

static void
_widgets_settings_option___lambda6_ (WidgetsSettingsOption* self)
{
	widgets_settings_option_update_image_resource (self);
}

static void
__widgets_settings_option___lambda6__g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
	_widgets_settings_option___lambda6_ ((WidgetsSettingsOption*) self);
}

static GObject *
widgets_settings_option_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsSettingsOption * self;
	const gchar* _tmp0_;
	GtkImage* _tmp1_;
	GtkGrid* card = NULL;
	GtkGrid* _tmp2_ = NULL;
	GtkGrid* _tmp3_;
	GtkImage* _tmp4_;
	GtkStyleContext* card_context = NULL;
	GtkGrid* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkCssProvider* _tmp10_;
	GtkLabel* title_label = NULL;
	const gchar* _tmp11_;
	GtkLabel* _tmp12_ = NULL;
	GtkLabel* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkWidget* _tmp15_;
	GtkWidget* _tmp16_;
	GtkWidget* _tmp17_;
	GtkWidget* _tmp18_;
	GtkLabel* description_label = NULL;
	const gchar* _tmp19_;
	GtkLabel* _tmp20_ = NULL;
	GtkGrid* _tmp21_;
	GtkLabel* _tmp22_;
	GtkWidget* _tmp23_;
	GtkLabel* _tmp24_;
	GtkSettings* _tmp25_;
	GtkSettings* _tmp26_;
	GtkSettings* _tmp27_;
	parent_class = G_OBJECT_CLASS (widgets_settings_option_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_SETTINGS_OPTION, WidgetsSettingsOption);
	_tmp0_ = self->priv->_image_path;
	_tmp1_ = (GtkImage*) gtk_image_new_from_resource (_tmp0_);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->image);
	self->priv->image = _tmp1_;
	_tmp2_ = (GtkGrid*) gtk_grid_new ();
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp2_);
	card = _tmp2_;
	_tmp3_ = card;
	_tmp4_ = self->priv->image;
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
	_tmp5_ = card;
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
	card_context = _tmp6_;
	_tmp7_ = card_context;
	gtk_style_context_add_class (_tmp7_, GRANITE_STYLE_CLASS_CARD);
	_tmp8_ = card_context;
	gtk_style_context_add_class (_tmp8_, GRANITE_STYLE_CLASS_ROUNDED);
	_tmp9_ = card_context;
	_tmp10_ = widgets_settings_option_css_provider;
	gtk_style_context_add_provider (_tmp9_, (GtkStyleProvider*) _tmp10_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp11_ = self->priv->_title;
	_tmp12_ = (GtkLabel*) gtk_label_new (_tmp11_);
	gtk_widget_set_halign ((GtkWidget*) _tmp12_, GTK_ALIGN_START);
	gtk_widget_set_valign ((GtkWidget*) _tmp12_, GTK_ALIGN_END);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp12_, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp12_, FALSE);
	g_object_ref_sink (_tmp12_);
	title_label = _tmp12_;
	_tmp13_ = title_label;
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
	gtk_style_context_add_class (_tmp14_, GRANITE_STYLE_CLASS_H3_LABEL);
	_tmp15_ = self->priv->_widget;
	gtk_widget_set_halign (_tmp15_, GTK_ALIGN_START);
	_tmp16_ = self->priv->_widget;
	gtk_widget_set_valign (_tmp16_, GTK_ALIGN_CENTER);
	_tmp17_ = self->priv->_widget;
	gtk_widget_set_hexpand (_tmp17_, FALSE);
	_tmp18_ = self->priv->_widget;
	gtk_widget_set_vexpand (_tmp18_, FALSE);
	_tmp19_ = self->priv->_description;
	_tmp20_ = (GtkLabel*) gtk_label_new (_tmp19_);
	gtk_label_set_xalign (_tmp20_, (gfloat) 0);
	gtk_widget_set_valign ((GtkWidget*) _tmp20_, GTK_ALIGN_START);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp20_, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp20_, FALSE);
	g_object_set (_tmp20_, "wrap", TRUE, NULL);
	gtk_label_set_justify (_tmp20_, GTK_JUSTIFY_LEFT);
	g_object_ref_sink (_tmp20_);
	description_label = _tmp20_;
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
	gtk_widget_set_margin_start ((GtkWidget*) self, 60);
	gtk_widget_set_margin_end ((GtkWidget*) self, 30);
	_tmp21_ = card;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp21_, 0, 0, 1, 3);
	_tmp22_ = title_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp22_, 1, 0, 1, 1);
	_tmp23_ = self->priv->_widget;
	gtk_grid_attach ((GtkGrid*) self, _tmp23_, 1, 1, 1, 1);
	_tmp24_ = description_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp24_, 1, 2, 1, 1);
	_tmp25_ = gtk_settings_get_default ();
	_tmp26_ = _g_object_ref0 (_tmp25_);
	_g_object_unref0 (self->priv->gtk_settings);
	self->priv->gtk_settings = _tmp26_;
	_tmp27_ = self->priv->gtk_settings;
	g_signal_connect_object ((GObject*) _tmp27_, "notify::gtk-application-prefer-dark-theme", (GCallback) __widgets_settings_option___lambda6__g_object_notify, self, 0);
	widgets_settings_option_update_image_resource (self);
	_g_object_unref0 (description_label);
	_g_object_unref0 (title_label);
	_g_object_unref0 (card);
	return obj;
}

static void
widgets_settings_option_class_init (WidgetsSettingsOptionClass * klass,
                                    gpointer klass_data)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	widgets_settings_option_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WidgetsSettingsOption_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_settings_option_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_settings_option_set_property;
	G_OBJECT_CLASS (klass)->constructor = widgets_settings_option_constructor;
	G_OBJECT_CLASS (klass)->finalize = widgets_settings_option_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SETTINGS_OPTION_IMAGE_PATH_PROPERTY, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_IMAGE_PATH_PROPERTY] = g_param_spec_string ("image-path", "image-path", "image-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SETTINGS_OPTION_TITLE_PROPERTY, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SETTINGS_OPTION_DESCRIPTION_PROPERTY, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SETTINGS_OPTION_WIDGET_PROPERTY, widgets_settings_option_properties[WIDGETS_SETTINGS_OPTION_WIDGET_PROPERTY] = g_param_spec_object ("widget", "widget", "widget", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	_tmp0_ = gtk_css_provider_new ();
	_g_object_unref0 (widgets_settings_option_css_provider);
	widgets_settings_option_css_provider = _tmp0_;
	_tmp1_ = widgets_settings_option_css_provider;
	gtk_css_provider_load_from_resource (_tmp1_, "/io/elementary/switchboard/SettingsOption.css");
}

static void
widgets_settings_option_instance_init (WidgetsSettingsOption * self,
                                       gpointer klass)
{
	self->priv = widgets_settings_option_get_instance_private (self);
}

static void
widgets_settings_option_finalize (GObject * obj)
{
	WidgetsSettingsOption * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_SETTINGS_OPTION, WidgetsSettingsOption);
	_g_free0 (self->priv->_image_path);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_description);
	_g_object_unref0 (self->priv->_widget);
	_g_object_unref0 (self->priv->image);
	_g_object_unref0 (self->priv->gtk_settings);
	G_OBJECT_CLASS (widgets_settings_option_parent_class)->finalize (obj);
}

static GType
widgets_settings_option_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsSettingsOptionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_settings_option_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsSettingsOption), 0, (GInstanceInitFunc) widgets_settings_option_instance_init, NULL };
	GType widgets_settings_option_type_id;
	widgets_settings_option_type_id = g_type_register_static (gtk_grid_get_type (), "WidgetsSettingsOption", &g_define_type_info, 0);
	WidgetsSettingsOption_private_offset = g_type_add_instance_private (widgets_settings_option_type_id, sizeof (WidgetsSettingsOptionPrivate));
	return widgets_settings_option_type_id;
}

GType
widgets_settings_option_get_type (void)
{
	static volatile gsize widgets_settings_option_type_id__volatile = 0;
	if (g_once_init_enter (&widgets_settings_option_type_id__volatile)) {
		GType widgets_settings_option_type_id;
		widgets_settings_option_type_id = widgets_settings_option_get_type_once ();
		g_once_init_leave (&widgets_settings_option_type_id__volatile, widgets_settings_option_type_id);
	}
	return widgets_settings_option_type_id__volatile;
}

static void
_vala_widgets_settings_option_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	WidgetsSettingsOption * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_SETTINGS_OPTION, WidgetsSettingsOption);
	switch (property_id) {
		case WIDGETS_SETTINGS_OPTION_IMAGE_PATH_PROPERTY:
		g_value_set_string (value, widgets_settings_option_get_image_path (self));
		break;
		case WIDGETS_SETTINGS_OPTION_TITLE_PROPERTY:
		g_value_set_string (value, widgets_settings_option_get_title (self));
		break;
		case WIDGETS_SETTINGS_OPTION_DESCRIPTION_PROPERTY:
		g_value_set_string (value, widgets_settings_option_get_description (self));
		break;
		case WIDGETS_SETTINGS_OPTION_WIDGET_PROPERTY:
		g_value_set_object (value, widgets_settings_option_get_widget (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_widgets_settings_option_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	WidgetsSettingsOption * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_SETTINGS_OPTION, WidgetsSettingsOption);
	switch (property_id) {
		case WIDGETS_SETTINGS_OPTION_IMAGE_PATH_PROPERTY:
		widgets_settings_option_set_image_path (self, g_value_get_string (value));
		break;
		case WIDGETS_SETTINGS_OPTION_TITLE_PROPERTY:
		widgets_settings_option_set_title (self, g_value_get_string (value));
		break;
		case WIDGETS_SETTINGS_OPTION_DESCRIPTION_PROPERTY:
		widgets_settings_option_set_description (self, g_value_get_string (value));
		break;
		case WIDGETS_SETTINGS_OPTION_WIDGET_PROPERTY:
		widgets_settings_option_set_widget (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

